import Vue from 'vue'
import store from 'vuejs/store'
import VUserBlock from 'vuejs/components/User/UserBlock'
import VMainContent from 'vuejs/components/Content/MainContent'

import { mapState } from 'vuex'

// require('theme/assets/styles/main.scss');
import 'theme/assets/styles/main.scss'

(function(Drupal, drupalSettings) {

  var MaterioTheme = function(){

    var v_user_block, v_main_content;
    // var _is_front = drupalSettings.path.isFront;


    console.log('drupalSettings', drupalSettings);

    //  ___      _ _
    // |_ _|_ _ (_) |_
    //  | || ' \| |  _|
    // |___|_||_|_|\__|
    function init(){
      console.log("MaterioTheme init()")
      initVues()
    }

    function initVues(){
      initUserVBlock()
      initVMainContent()
    }

    function initUserVBlock(){
      let mount_point = drupalSettings.user.uid !== 0 ? '#block-userblock' : '#block-userlogin';
      let props = {
        title: ""
      };
      switch (mount_point) {
        case '#block-userlogin':
          let $block = document.querySelector(mount_point);
          props = {
            title: $block.querySelector('h2').textContent,
            form: {
              ph_email: $block.querySelector('input#edit-name').getAttribute('placeholder'),
              ph_pass: $block.querySelector('input#edit-pass').getAttribute('placeholder'),
              btn_value: $block.querySelector('input#edit-submit').getAttribute('value'),
              register: {
                title: $block.querySelector('a.create-account-link').textContent,
                href: $block.querySelector('a.create-account-link').getAttribute('href')
              },
              reset: {
                title: $block.querySelector('a.request-password-link').textContent,
                href: $block.querySelector('a.request-password-link').getAttribute('href')
              }
            }
          }
          break;
        case '#block-userblock':
        default:
          break;
      }
      // console.log(props);

      v_user_block = new Vue({
        store,
        computed: {
          ...mapState({
            isloggedin: state => state.User.isloggedin
          })
        },
        created () {
          if(drupalSettings.user.uid !== 0){
            this.$store.commit('User/setUid', drupalSettings.user.uid)
            this.$store.dispatch('User/getUser')
          }
        },
        render: h => h(VUserBlock, {props:props})
      }).$mount(mount_point)
      console.log('initUserVBlock', v_user_block);
    }

    function initVMainContent(){
      let $main_content = document.querySelector('#main-content')
      console.log('main-content', $main_content);
      let main_html = $main_content.innerHTML
      v_main_content = new Vue({
        store,
        render: h => h(VMainContent, {props:{html:main_html}})
      }).$mount('#main-content')
      // console.log('initTestVContent', v_test_content);
    }

    init()
  } // end MaterioTheme()

  var materiotheme = new MaterioTheme();

})(Drupal, drupalSettings);
